"""The base class for the SHV API definitions."""

import abc
import collections.abc

import shv


class SHVAPI(abc.ABC):
    """The SHV API definition.

    This provides method descriptions based on the API configuration.
    """

    @abc.abstractmethod
    def methods(self) -> collections.abc.Iterator[shv.RpcMethodDesc]:
        """Iterate over methods of this API."""
