"""The application SHV API."""

import collections.abc

import shv

from .abc import SHVAPI


class SHVApplication(SHVAPI):
    """The application API."""

    def __init__(
        self,
        name: str | None = None,
        description: str = "",
    ) -> None:
        self._name = name
        self._description = description

    @property
    def name(self) -> str | None:
        """The application name."""
        return self._name

    @property
    def description(self) -> str:
        """Description of this application."""
        return self._description

    def methods(self) -> collections.abc.Iterator[shv.RpcMethodDesc]:  # noqa: D102
        return iter([])
